This commit is contained in:
awalsh128 2022-06-03 21:45:03 -07:00
commit 6fe1db8111
5 changed files with 31 additions and 39 deletions

View file

@ -25,9 +25,6 @@ outputs:
# This compound expression is needed because lhs can be empty.
# Need to output true and false instead of true and nothing.
value: ${{ steps.load-cache.outputs.cache-hit || false }}
cache-key:
description: 'The key where the cache is stored with packages, their versions, and the cache version (i.e. package=version package=version @ 1).'
value: ${{ steps.pre-cache.outputs.cache-key }}
package-version-list:
description: 'The packages and versions that are installed as a comma delimited list with colon delimit on the package version (i.e. <package>:<version,<package>:<version>).'
value: ${{ steps.post-cache.outputs.package-version-list }}
@ -42,7 +39,6 @@ runs:
"${{ inputs.version }}" \
${{ inputs.packages }}
echo "CACHE_KEY=$(cat ~/cache-apt-pkgs/cache_key.md5)" >> $GITHUB_ENV
echo "::set-output name=cache-key::$(cat ~/cache-apt-pkgs/cache_key.md5)"
shell: bash
- id: load-cache

View file

@ -8,7 +8,7 @@ script_dir="$(dirname -- "$(realpath -- "${0}")")"
source "${script_dir}/lib.sh"
# Directory that holds the cached packages.
cache_dir="${1}"
cache_dir=$1
# List of the packages to use.
input_packages="${@:2}"
@ -27,7 +27,7 @@ echo -n "Updating APT package list..."
sudo apt-get update > /dev/null
echo "done."
manifest=
manifest=""
echo "Clean installing and caching ${package_count} packages..."
for package in "${packages}"; do
get_package_name_ver "${package}" # -> package_name, package_ver

View file

@ -4,23 +4,23 @@
set -e
# Directory that holds the cached packages.
cache_dir="${1}"
cache_dir=$1
# Root directory to untar the cached packages to.
# Typically filesystem root '/' but can be changed for testing.
cache_restore_root="${2}"
cache_restore_root=$2
# Indicates that the cache was found.
cache_hit="${3}"
cache_hit=$3
# List of the packages to use.
packages="${@:4}"
script_dir="$(dirname -- "$(realpath -- "${0}")")"
script_dir=$(dirname $0)
if [ "${cache_hit}" == true ]; then
"${script_dir}/restore_pkgs.sh" ~/cache-apt-pkgs "${cache_restore_root}"
if [ "$cache_hit" == true ]; then
$script_dir/restore_pkgs.sh ~/cache-apt-pkgs $cache_restore_root
else
"${script_dir}/install_and_cache_pkgs.sh" ~/cache-apt-pkgs "${packages}"
$script_dir/install_and_cache_pkgs.sh ~/cache-apt-pkgs $packages
fi
echo ""

View file

@ -5,10 +5,10 @@ script_dir="$(dirname -- "$(realpath -- "${0}")")"
source "${script_dir}/lib.sh"
# Directory that holds the cached packages.
cache_dir="${1}"
cache_dir=$1
# Version of the cache to create or load.
cache_version="${2}"
version=$2
# List of the packages to use.
input_packages="${@:3}"
@ -17,15 +17,15 @@ input_packages="${@:3}"
packages="$(normalize_package_list "${input_packages}")"
# Create cache directory so artifacts can be saved.
mkdir -p "${cache_dir}"
echo -n "Validating action arguments (version='${cache_version}', packages='${packages}')...";
mkdir -p $cache_dir
echo -n "Validating action arguments (version='$version', packages='$packages')...";
if grep -q " " <<< "${cache_version}"; then
echo "aborted."
echo "Version value '${cache_version}' cannot contain spaces." >&2
echo "Version value '$version' cannot contain spaces." >&2
exit 1
fi
# Is length of string zero?
if test -z "${packages}"; then
echo "aborted."
@ -34,16 +34,12 @@ if test -z "${packages}"; then
fi
echo "done."
echo -n "Updating APT package list..."
sudo apt-get update > /dev/null
echo "done."
versioned_packages=""
echo -n "Verifying packages..."
for package in ${packages}; do
if test ! "$(apt show "${package}")"; then
echo "aborted."
echo "Package '${package}' not found." >&2
echo "Package '$package' not found." >&2
exit 3
fi
get_package_name_ver "${package}" # -> package_name, package_ver
@ -68,6 +64,6 @@ echo "- Value hashed as '${key}'."
echo "done."
key_filepath="${cache_dir}/cache_key.md5"
echo "${key}" > "${key_filepath}"
echo "Hash value written to ${key_filepath}"
key_filepath="$cache_dir/cache_key.md5"
echo $key > $key_filepath
echo "Hash value written to $key_filepath"

View file

@ -4,16 +4,16 @@
set -e
# Directory that holds the cached packages.
cache_dir="${1}"
cache_dir=$1
# Root directory to untar the cached packages to.
# Typically filesystem root '/' but can be changed for testing.
cache_restore_root="${2}"
cache_restore_root=$2
cache_filepaths="$(ls -1 "${cache_dir}" | sort)"
echo "Found $(echo "${cache_filepaths}" | wc -w) files in the cache."
for cache_filepath in ${cache_filepaths}; do
echo "- $(basename "${cache_filepath}")"
cache_filepaths=$(ls -1 $cache_dir | sort)
echo "Found $(echo $cache_filepaths | wc -w) files in the cache."
for cache_filepath in $cache_filepaths; do
echo "- $(basename $cache_filepath)"
done
echo "Reading from manifest..."
@ -23,12 +23,12 @@ done
echo "done."
# Only search for archived results. Manifest and cache key also live here.
cache_pkg_filepaths=$(ls -1 ${cache_dir}/*.tar.gz | sort)
cache_pkg_filecount=$(echo "${cache_pkg_filepaths}" | wc -w)
echo "Restoring ${cache_pkg_filecount} packages from cache..."
for cache_pkg_filepath in ${cache_pkg_filepaths}; do
echo -n "- $(basename "${cache_pkg_filepath}") restoring..."
sudo tar -xf ${cache_pkg_filepath} -C ${cache_restore_root} > /dev/null
cache_pkg_filepaths=$(ls -1 $cache_dir/*.tar.gz | sort)
cache_pkg_filecount=$(echo $cache_pkg_filepaths | wc -w)
echo "Restoring $cache_pkg_filecount packages from cache..."
for cache_pkg_filepath in $cache_pkg_filepaths; do
echo -n "- $(basename $cache_pkg_filepath) restoring..."
sudo tar -xf $cache_pkg_filepath -C $cache_restore_root > /dev/null
echo "done."
done
echo "done."